setwd("C:/Users/Gidon Frischkorn/Documents/Publications/Manuscripts/JoI - ModerationWPA/Revision 2.0/Supplementaries/Supplement")

#Read data from supplementary datafiles
data_S1 <- read.table("WPA_S1_data.txt", header = TRUE, sep = "\t")
data_S3 <- read.table("WPA_S3_data.txt", header = TRUE, sep = "\t")
data_S5 <- read.table("WPA_S5_data.txt", header = TRUE, sep = "\t")

X <- 9 #define number of percentiles
Y <- 5 #define percentile to be centered to

library(nlme)
#Estimate MLM for Sternberg condition S1
#Define and compute percentile variables
data_S1$perc <- as.numeric(data_S1$perc)
data_S1$perc.center <- data_S1$perc - Y

#Baseline-Model: Random intercept, no slope model
mod0 <- lme(z_RT ~ 1, random = ~1|Subject, data = data_S1,
            method ="ML", na.action = na.omit, 
            control = lmeControl(opt = "optim"))

#Random Intercept - - Random Slope: p
mod1 <- lme(z_RT ~ 1,
            random = ~1 + perc.center|Subject, data = data_S1, method ="ML", na.action = na.omit,
            control = lmeControl(opt = "optim"))

#Random Intercept - Fixed Slope:  g - Random Slope: p
mod2 <- lme(z_RT ~ Z_gMean,
            random = ~1 + perc.center |Subject, data = data_S1, method ="ML", na.action = na.omit,
            control = lmeControl(opt = "optim"))

#Random Intercept - Fixed Slope: g, p:g - Random Slope: p
mod3 <- lme(z_RT ~ Z_gMean + perc.center:Z_gMean,
            random = ~1 + perc.center |Subject, data = data_S1, method ="ML", na.action = na.omit,
            control = lmeControl(opt = "optim"))

Fit_S1 <- anova(mod0, mod1, mod2, mod3)
Fit_S1
summary(mod3)
summary(mod2)

#Estimate MLM for Sternberg condition S3
#Define and compute percentile variables
data_S3$perc <- as.numeric(data_S3$perc)
data_S3$perc.center <- data_S3$perc - Y

#Baseline-Model: Random intercept, no slope model
mod0 <- lme(z_RT ~ 1, random = ~1|Subject, data = data_S3,
            method ="ML", na.action = na.omit, 
            control = lmeControl(opt = "optim"))

#Random Intercept - - Random Slope: p
mod1 <- lme(z_RT ~ 1,
            random = ~1 + perc.center|Subject, data = data_S3, method ="ML", na.action = na.omit,
            control = lmeControl(opt = "optim"))

#Random Intercept - Fixed Slope:  g - Random Slope: p
mod2 <- lme(z_RT ~ Z_gMean,
            random = ~1 + perc.center |Subject, data = data_S3, method ="ML", na.action = na.omit,
            control = lmeControl(opt = "optim"))

#Random Intercept - Fixed Slope: g, p:g - Random Slope: p
mod3 <- lme(z_RT ~ Z_gMean + perc.center:Z_gMean,
            random = ~1 + perc.center |Subject, data = data_S3, method ="ML", na.action = na.omit,
            control = lmeControl(opt = "optim"))

Fit_S3 <- anova(mod0, mod1, mod2, mod3)
Fit_S3
summary(mod4)

#Estimate MLM for Sternberg condition S3
#Define and compute percentile variables
data_S5$perc <- as.numeric(data_S5$perc)
data_S5$perc.center <- data_S5$perc - Y

#Baseline-Model: Random intercept, no slope model
mod0 <- lme(z_RT ~ 1, random = ~1|Subject, data = data_S5,
            method ="ML", na.action = na.omit, 
            control = lmeControl(opt = "optim"))

#Random Intercept - - Random Slope: p
mod1 <- lme(z_RT ~ 1,
            random = ~1 + perc.center|Subject, data = data_S5, method ="ML", na.action = na.omit,
            control = lmeControl(opt = "optim"))

#Random Intercept - Fixed Slope:  g - Random Slope: p
mod2 <- lme(z_RT ~ Z_gMean,
            random = ~1 + perc.center |Subject, data = data_S5, method ="ML", na.action = na.omit,
            control = lmeControl(opt = "optim"))

#Random Intercept - Fixed Slope: g, p:g - Random Slope: p
mod3 <- lme(z_RT ~ Z_gMean + perc.center:Z_gMean,
            random = ~1 + perc.center |Subject, data = data_S5, method ="ML", na.action = na.omit,
            control = lmeControl(opt = "optim"))

Fit_S5 <- anova(mod0, mod1, mod2, mod3)
Fit_S5
summary(mod3)
