setwd("C:/Users/Gidon Frischkorn/Documents/Publications/Manuscripts/JoI - ModerationWPA/Revision 2.0/Supplementaries/Supplement")

#Read data from supplementary datafiles
data_S1 <- read.table("WPA_S1_data.txt", header = TRUE, sep = "\t")
data_S3 <- read.table("WPA_S3_data.txt", header = TRUE, sep = "\t")
data_S5 <- read.table("WPA_S5_data.txt", header = TRUE, sep = "\t")

X <- 9 #define number of percentiles
Y <- 5 #define percentile to be centered to

#Sequential Regression Analysis for memory Set Size 1 
perc <- c(1:X)
p <- 1
Coeff_cond1  <- as.data.frame(matrix(rep(NA,11),1,11))
colnames(Coeff_cond1) <- c("Intercept", "dum$Z_gMean", "Corr", "Cov", "SD_RT", "SD_IQ",
                           "SE_Int", "SE_b", "R square", "p Value", "F Value")

for(p in perc){
  dum <- subset(data_S1, perc == p)
  Reg <- lm(dum$z_RT ~ dum$Z_gMean)
  Rsquare <- summary(Reg)$r.squared
  pVal <- anova(Reg)$'Pr(>F)'[1]
  Fval <- summary(Reg)$fstatistic[1]
  Corr <- cor(dum$z_RT, dum$Z_gMean)
  Covar <- cov(dum$z_RT, dum$Z_gMean)
  SD_RT  <- sd(dum$z_RT)
  SD_IQ  <- sd(dum$Z_gMean)
  SE_Int <- summary(Reg)$coefficients[1,2]
  SE_b <- summary(Reg)$coefficients[2,2]
  dim <- cbind(Reg$coefficients[1], Reg$coefficients[2], Corr, Covar, SD_RT, SD_IQ,
               SE_Int, SE_b, Rsquare, pVal, Fval)
  colnames(dim) <- c("Inter", "b", "Corr", "Cov", "SD_RT", "SD_IQ", 
                     "SE_Int", "SE_b", "R square", "p Value", "F Value")
  dim <- as.vector(dim)
  Coeff_cond1  <- rbind(Coeff_cond1, dim)
}
Coeff_cond1 <- Coeff_cond1[-1,]
colnames(Coeff_cond1)  <- c("Inter", "b", "Corr", "Cov", "SD_RT", "SD_IQ", 
                            "SE_Int", "SE_b", "R square", "p Value", "F Value")
percentile  <- rep(1:X)
Coeff_cond1 <- cbind(Coeff_cond1, percentile)
rm(Corr, dim, p, perc, percentile, pVal, Reg, Rsquare, SD_IQ, SD_RT)

Coeff_cond1$percentile <- Coeff_cond1$percentile-Y
Coeff_cond1$percentile2 <- Coeff_cond1$percentile^2
Coeff_cond1$percentile3 <- Coeff_cond1$percentile^3

WPR_cond1 <- lm(Coeff_cond1$b ~ Coeff_cond1$percentile)
summary(WPR_cond1)

#Sequential Regression Analysis for memory Set Size 3 
perc <- c(1:X)
p <- 1
Coeff_cond2  <- as.data.frame(matrix(rep(NA,11),1,11))
colnames(Coeff_cond2) <- c("Intercept", "dum$Z_gMean", "Corr", "Cov", "SD_RT", "SD_IQ",
                           "SE_Int", "SE_b", "R square", "p Value", "F Value")

for(p in perc){
  dum <- subset(data_S3, perc == p)
  Reg <- lm(dum$z_RT ~ dum$Z_gMean)
  Rsquare <- summary(Reg)$r.squared
  pVal <- anova(Reg)$'Pr(>F)'[1]
  Fval <- summary(Reg)$fstatistic[1]
  Corr <- cor(dum$z_RT, dum$Z_gMean)
  Covar <- cov(dum$z_RT, dum$Z_gMean)
  SD_RT  <- sd(dum$z_RT)
  SD_IQ  <- sd(dum$Z_gMean)
  SE_Int <- summary(Reg)$coefficients[1,2]
  SE_b <- summary(Reg)$coefficients[2,2]
  dim <- cbind(Reg$coefficients[1], Reg$coefficients[2], Corr, Covar, SD_RT, SD_IQ,
               SE_Int, SE_b, Rsquare, pVal, Fval)
  colnames(dim) <- c("Inter", "b", "Corr", "Cov", "SD_RT", "SD_IQ", 
                     "SE_Int", "SE_b", "R square", "p Value", "F Value")
  dim <- as.vector(dim)
  Coeff_cond2  <- rbind(Coeff_cond2, dim)
}
Coeff_cond2 <- Coeff_cond2[-1,]
colnames(Coeff_cond2)  <- c("Inter", "b", "Corr", "Cov", "SD_RT", "SD_IQ", 
                            "SE_Int", "SE_b", "R square", "p Value", "F Value")
percentile  <- rep(1:X)
Coeff_cond2 <- cbind(Coeff_cond2, percentile)
rm(Corr, dim, p, perc, percentile, pVal, Reg, Rsquare, SD_IQ, SD_RT)

Coeff_cond2$percentile <- Coeff_cond2$percentile-Y
Coeff_cond2$percentile2 <- Coeff_cond2$percentile^2
Coeff_cond2$percentile3 <- Coeff_cond2$percentile^3

WPR_cond2 <- lm(Coeff_cond2$b ~ Coeff_cond2$percentile)
summary(WPR_cond2)

#Sequential Regression Analysis for memory Set Size 5 
perc <- c(1:X)
p <- 1
Coeff_cond3  <- as.data.frame(matrix(rep(NA,11),1,11))
colnames(Coeff_cond3) <- c("Intercept", "dum$Z_gMean", "Corr", "Cov", "SD_RT", "SD_IQ",
                           "SE_Int", "SE_b", "R square", "p Value", "F Value")

for(p in perc){
  dum <- subset(data_S5, perc == p)
  Reg <- lm(dum$z_RT ~ dum$Z_gMean)
  Rsquare <- summary(Reg)$r.squared
  pVal <- anova(Reg)$'Pr(>F)'[1]
  Fval <- summary(Reg)$fstatistic[1]
  Corr <- cor(dum$z_RT, dum$Z_gMean)
  Covar <- cov(dum$z_RT, dum$Z_gMean)
  SD_RT  <- sd(dum$z_RT)
  SD_IQ  <- sd(dum$Z_gMean)
  SE_Int <- summary(Reg)$coefficients[1,2]
  SE_b <- summary(Reg)$coefficients[2,2]
  dim <- cbind(Reg$coefficients[1], Reg$coefficients[2], Corr, Covar, SD_RT, SD_IQ,
               SE_Int, SE_b, Rsquare, pVal, Fval)
  colnames(dim) <- c("Inter", "b", "Corr", "Cov", "SD_RT", "SD_IQ", 
                     "SE_Int", "SE_b", "R square", "p Value", "F Value")
  dim <- as.vector(dim)
  Coeff_cond3  <- rbind(Coeff_cond3, dim)
}
Coeff_cond3 <- Coeff_cond3[-1,]
colnames(Coeff_cond3)  <- c("Inter", "b", "Corr", "Cov", "SD_RT", "SD_IQ", 
                            "SE_Int", "SE_b", "R square", "p Value", "F Value")
percentile  <- rep(1:X)
Coeff_cond3 <- cbind(Coeff_cond3, percentile)
rm(Corr, dim, p, perc, percentile, pVal, Reg, Rsquare, SD_IQ, SD_RT)

Coeff_cond3$percentile <- Coeff_cond3$percentile-Y
Coeff_cond3$percentile2 <- Coeff_cond3$percentile^2
Coeff_cond3$percentile3 <- Coeff_cond3$percentile^3

WPR_cond3 <- lm(Coeff_cond3$b ~ Coeff_cond3$percentile)
summary(WPR_cond3)
