setwd("C:/Users/Gidon Frischkorn/Documents/Publications/Manuscripts/JoI - ModerationWPA/Revision 2.0/Supplementaries/Supplement")

#Read data from supplementary datafiles
data_S1 <- read.table("WPA_S1_data.txt", header = TRUE, sep = "\t")
data_S3 <- read.table("WPA_S3_data.txt", header = TRUE, sep = "\t")
data_S5 <- read.table("WPA_S5_data.txt", header = TRUE, sep = "\t")

#reshape data to compute correlations between RTs in fastest and slowest percentiles
data_RT1 <- data_S1[c("Subject","perc" , "RT_mean")]
data_RT3 <- data_S3[c("Subject","perc" , "RT_mean")]
data_RT5 <- data_S5[c("Subject","perc" , "RT_mean")]
library(reshape2)
data_RT1 <- dcast(data_RT1, Subject ~ perc)
data_RT3 <- dcast(data_RT3, Subject ~ perc)
data_RT5 <- dcast(data_RT5, Subject ~ perc)

#Compute correlations between RTs in fastest and slowest percentile across conditions
r_19_S1 <- cor(data_RT1$`1`, data_RT1$`9`)
r_19_S3 <- cor(data_RT3$`1`, data_RT3$`9`)
r_19_S5 <- cor(data_RT5$`1`, data_RT5$`9`)

#Compute correlations between RT and g in fastest and slowest percentiles
data_S1_p1 <- subset(data_S1, perc == 1)
data_S1_p9 <- subset(data_S1, perc == 9)
data_S3_p1 <- subset(data_S3, perc == 1)
data_S3_p9 <- subset(data_S3, perc == 9)
data_S5_p1 <- subset(data_S5, perc == 1)
data_S5_p9 <- subset(data_S5, perc == 9)

r_S1_p1 <- cor(data_S1_p1$RT_mean, data_S1_p1$Z_gMean)
r_S1_p9 <- cor(data_S1_p9$RT_mean, data_S1_p9$Z_gMean)
r_S3_p1 <- cor(data_S3_p1$RT_mean, data_S3_p1$Z_gMean)
r_S3_p9 <- cor(data_S3_p9$RT_mean, data_S3_p9$Z_gMean)
r_S5_p1 <- cor(data_S5_p1$RT_mean, data_S5_p1$Z_gMean)
r_S5_p9 <- cor(data_S5_p9$RT_mean, data_S5_p9$Z_gMean)

#compare correlations between RT and g in fastest and slowest percentiles
library(cocor)
cocor.dep.groups.overlap(r_S1_p1, r_S1_p9, r_19_S1, n = 121)
cocor.dep.groups.overlap(r_S3_p1, r_S3_p9, r_19_S3, n = 121)
cocor.dep.groups.overlap(r_S5_p1, r_S5_p9, r_19_S5, n = 121)

#Correlations between mean RT in RTbands across the three conditions
cor(data_RT1[,2:10])
cor(data_RT3[,2:10])
cor(data_RT5[,2:10])
